/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package visuAnalec.chaines;

import java.awt.*;
import java.util.*;
import java.util.ArrayList;
import visuAnalec.elements.*;
import visuAnalec.texte.*;
import visuAnalec.vue.*;

/**
 *
 * @author Bernard
 */
public class ModeleChaines {
  static class Chainon {
    Unite unite;
    String texte;
    Schema chaine = null;
    int nbEltsChaine = 0;
    String idChaine = "";
    int noChaine = 0;
    Chainon(Unite unite, String texte) {
      this.unite = unite;
      this.texte = texte;
    }
  }
  private Vue vue;
  private GChaines panneauGraphique;
  private Unite[] listeUnites;
  HashMap<Unite, Chainon> chainonsUnites = new HashMap<Unite, Chainon>();
  HashMap<Schema, ArrayList<Unite>> unitesChaines = new HashMap<Schema, ArrayList<Unite>>();
  public ModeleChaines(Vue vue, GChaines panneauGraphique) {
    this.vue = vue;
    this.panneauGraphique = panneauGraphique;
  }
  Unite[] getUnites() {
    return listeUnites;
  }
  Unite[] getUnitesChaine(Schema chaine) {
    ArrayList<Unite> units = unitesChaines.get(chaine);
    return units.toArray(new Unite[0]);
  }
  void init(String typeChaines, String typeUnites, Color[] coulNbElts, int[] seuilsCoul) throws Exception {
    listeUnites = vue.getUnitesAVoir(typeUnites);
    Chainon[] chainons = new Chainon[listeUnites.length];
    for (int i = 0; i < listeUnites.length; i++) {
      chainons[i] = new Chainon(listeUnites[i], vue.getTexteUnite(listeUnites[i]));
      chainonsUnites.put(listeUnites[i], chainons[i]);
    }
    HashMap<Schema, Integer> nbEltsChaine = new HashMap<Schema, Integer>();
    HashMap<Schema, Integer> noChaine = new HashMap<Schema, Integer>();
    int no = 0;
    for (Schema chaine : vue.getSchemasAVoir(typeChaines)) {
      unitesChaines.put(chaine, new ArrayList<Unite>());
      int nbElts = 0;
      for (Element elt : chaine.getContenu()) {
        if (elt.getClass() == Unite.class && elt.getType().equals(typeUnites)) {
          if (chainonsUnites.get(elt).chaine != null) {
            throw new Exception("L'unité " + vue.getIdElement(elt) + " appartient à deux chaînes : " +
                    vue.getIdElement(chaine) + " et " + vue.getIdElement(chainonsUnites.get(elt).chaine));
          } else {
            chainonsUnites.get(elt).chaine = chaine;
            unitesChaines.get(chaine).add((Unite) elt);
            nbElts++;
          }
        }
      }
      nbEltsChaine.put(chaine, nbElts);
      noChaine.put(chaine, nbElts > 1 ? ++no : 0);
    }
    for (Unite unit : listeUnites) {
      Chainon chainon = chainonsUnites.get(unit);
      if (chainon.chaine != null) {
        chainon.nbEltsChaine = nbEltsChaine.get(chainon.chaine);
        chainon.noChaine = noChaine.get(chainon.chaine);
        chainon.idChaine = vue.getIdElement(chainon.chaine);
      }
    }
//    int[] noPar = PanneauTexte.calculerNoParagraphe(listeUnites, vue.getCorpus().getFinParagraphes());
    int[] noPar =vue.getCorpus().calculerNoParagraphe(listeUnites);
    panneauGraphique.afficher(chainons, noPar);
  }
  void initVide() {
    listeUnites = new Unite[0];
    chainonsUnites.clear();
    unitesChaines.clear();
    panneauGraphique.effacerTout();
  }
  void setChampAffiche(String champ, HashMap<String, Color> couleursValeursChamp) {
    panneauGraphique.changerCouleurs(colorerChamp(champ, couleursValeursChamp));
  }
  void setChampAfficheNbElts(Color[] couleurs, int[] seuils) {
    panneauGraphique.changerCouleurs( colorerNbElts(couleurs, seuils));
  }
  private Color[] colorerNbElts(Color[] couleurs, int[] seuils) {
    Color[] couls = new Color[listeUnites.length];
    for (int i = 0; i < listeUnites.length; i++) {
      Chainon ch = chainonsUnites.get(listeUnites[i]);
      if (ch.chaine == null) couls[i] = Color.WHITE;
      else {
        int nbElts = ch.nbEltsChaine;
        couls[i] = nbElts == 1 ? couleurs[0] : nbElts <= seuils[0] ? couleurs[1] : 
          nbElts <= seuils[1] ? couleurs[2] : couleurs[3];
      }
    }
    return couls;
  }
  private Color[] colorerChamp(String champ, HashMap<String, Color> couleursValeursChamp) {
    Color[] couls = new Color[listeUnites.length];
    for (int i = 0; i < listeUnites.length; i++) {
      Chainon ch = chainonsUnites.get(listeUnites[i]);
      couls[i] = couleursValeursChamp.get(vue.getValeurChamp(ch.unite, champ));
    }
    return couls;
  }
}
